:i	static char d_open_sccs_id[] = "%W% %G%";
:1#include "V_s.h"
/*
* This is a debug wrapper around the Unix open() system call.  Note that V.h
* defines  several  Open*()  macros for calling d_open(), mostly because the C
* preprocessor can't handle macros with variable numbers of parameters.
*
* If  your system has the syscall() routine and the SYS_* symbols are defined,
* then we will use them to do the system  call,  and  define  our  own  open()
* routine,  allowing  the  debug  package  to  intercept  calls of open(f) and
* generate debug output.
*/
#if defined(USE_syscall) && defined(SYS_open)
open(n,f,m) char *n; {return syscall(SYS_open,n,f,m);}
#endif

d_open(name,flags,mode)
	char *name;
{	int   v;
	int   e;
:8	V8s "open(\"%s\",%08lX,0%o)",name,flags,mode D;
	errno = 0;
	v = open(name,flags,mode);
	e = errno;
:6	V6s "open(\"%s\",%08lX,0%o)=%d [Err %d=%s=%s]",name,flags,mode,v,Errinfo D;
	if (v >= 0) {
		d_newfile(File_LOCAL,v,name,"open");
	}
	errno = e;
	return v;
}
