:i	static char d_select_sccs_id[] = "%W% %G%";
:1#include "V_S.h"
/*
#include "pktime.h"
*
* Learning why select() is failing can be an insane task ...
*/
:n	global int dbn_select = 0;	/* Select counter */

d_select(n,r,w,x,t)
	int  n;
	U32 *r, *w, *x;
	TIMV*t;
{	int  v;
	int  ss, ms, us;
	fd_set *rp,*wp,*xp;
:6	long t0, t1;
	int   e=0;
:f	Fenter("Select");
:6	V6S "(n=%d,r=%08lX,w=%08lX,x=%08lX,t=%08lX)",n,r,w,x,t D;
:5	ss = t ? t->tv_sec : 0;
:5	us = t ? t->tv_usec : 0;
:5	ms = t ? us / 1000 : 0;
:5	if (r)
:5		V6S "rmask=%08X",*r D;
:5	if (w)
:5		V6S "wmask=%08X",*w D;
:5	if (x)
:5		V6S "emask=%08X",*x D;
:5	if (t)
:5		V6S "tmout=%d.%06d",ss,us D;
:6	if (Vflg['S']>3) UnixTime(&t0);
:9	fprintf(stderr,"before select(%d,%08X=%04X,-,-,%08X=%d.%06d)\n",
:9		n,r,r?*r:0,t,t?t->tv_sec:0,t?t->tv_usec:0);

	rp = (fd_set*)r;
	wp = (fd_set*)w;
	xp = (fd_set*)x;
:5	errno = 0;

	v = select(n,rp,wp,xp,t);
	e = errno;

:9	fprintf(stderr,"after  select(%d,%08X=%04X,-,-,%08X=%d.%06d)=%d\n",
:9		n,r,*r,t,t?t->tv_sec:0,t?t->tv_usec:0,v);
:n	++dbn_select;
:9	if (e > 1000) fprintf(stderr,"### select() gave errno=%d.\n",e);
:6	if (Vflg['S']>3) UnixTime(&t1);
:6	V6S "select(%d,%06lX,%06lX,%06lX,%06lX)=%d [Err %d=%s=%s]"
:6		,n,r,w,x,t,v,Errinfo D;
:6	if (t && (Vflg['S'] > 5) && ((t1 - t0) < ss))
:6		V6S "select(%d,...,%d.%03d)=%d after %d sec [Err %d=%s]",
:6			n,ss,ms,v,t1-t0,Errinfo D;
:5	if (r && *r)
:5		V6S "Return rmask=%08X",*r D;
:5	if (w && *w)
:5		V6S "Return wmask=%08X",*w D;
:5	if (x && *x)
:5		V6S "Return emask=%08X",*x D;
:6	V6S "Return %d after %d seconds.",v,t1-t0 D;
	errno = e;
:f	Fexit;
	return v;
}
